<?php

namespace app\admin\controller;

use think\Controller;
use think\Cookie;
use think\Db;
use app\common\util\PclZip;
use app\common\util\Dir;

include './addons/auto/func.php';
class Auto extends \app\common\controller\Admin
{

    public function __construct()
    {
        parent::__construct();
    }
    // 初始化
    public function initialize()
    {
        $pre = config('database.prefix');
        $tableName = $pre . "autolog";
        $isTable = db()->query('SHOW TABLES LIKE ' . "'" . $tableName . "'");
        if (!$isTable) {
            $sql = "CREATE TABLE `{$tableName}` (
                  `id` int(11) NOT NULL AUTO_INCREMENT,
                  `name` varchar(64) DEFAULT NULL COMMENT '资源站名称',
                  `old` varchar(150) DEFAULT NULL COMMENT '老域名',
                  `new` varchar(150) DEFAULT NULL COMMENT '新域名',
                  `type` varchar(32) DEFAULT NULL COMMENT '类型',
                  `runtime` datetime DEFAULT NULL COMMENT '运行时间',
                  `updatesql` longtext NOT NULL,
                  PRIMARY KEY (`id`),
                 KEY `old` (`old`,`new`,`type`),
                 KEY `runtime` (`runtime`)
                ) ENGINE=InnoDB DEFAULT CHARSET=utf8;";
            $zxjg = db()->query($sql); 
            $routname=$pre."auth_rule";
            Db::table($routname)->insert(['module'=>"admin",'name' => "admin/auto/index",'title'=>"牛牛助手",'icon' =>"fa fa-television", 'type'=>"2",'status' => "1","remark"=>'']); 
            $req = include './addons/auto/lib/extra/autoconf.php'; 
            $requesturl =$req['url']; 
            require('./addons/auto/config/config.php');
            $tok = $rq['Auto']['token'];
            $sitename=config('site.site_name');
            $hosts=$GLOBALS['_SERVER']['HTTP_HOST'];
            $scheme=$GLOBALS['_SERVER']['REQUEST_SCHEME']; 
            $get='&sitename='.$hosts.'&serverip='.$GLOBALS['_SERVER']['SERVER_ADDR'].'&msgname=&seoname='.$sitename.'&msg=&vod=&img=1&api=1&update=&play=1&uri=&from=&auto=&token='.$tok.'&apiinfo=&type=zanpiancmsv9&http='.$scheme; 
            zanpian_curl_get($requesturl . '/?msg.html'.$get);
        } else {
            return 0;
        }
    }
    // 首页
    public function index()
    { 
        $param = input();
        $this->initialize(); //初始化创建数据库 
        $req = include './addons/auto/lib/extra/autoconf.php'; 
        $requesturl =$req['url']; 
        $res = https_request($requesturl . '/?api.html', '', '', 1500, 3);
        $arrres = auto_json_decode($res); 
        $imglist = $arrres['imglist'];
        $apilist = $arrres['apilist'];
        $v10list = $arrres['v10list']; 
        require('./addons/auto/config/config.php');
        $version = $arrres['code'];
        $not = $arrres['info']; 
        $hostversion = $req['version'];
        $this->assign("hostversion",$hostversion);
        $this->assign("versions",$version); 
        $this->assign( "rq",$rq);
        $this->assign( "not",$not);
        $this->assign( $req);
        $this->assign("apilist", $apilist);
        $this->assign($v10list);
        $this->assign("imglist", $imglist);   
        return $this->fetch("", array(), array("</body>" => config("zanpian.zanpian_body") . "</body>"));
        
    }
    public function addplay()
    {
        $data = $this->request->get();
        $collect = model("collect");
        $collect->validate("collect")->allowField(true)->save($data);
        $model = model("Play");
        $model->validate("Play.add")->save($data);
        $model->play_cache();


    }
    public function cron()

    {
        
        $data = $this->request->get(); 
        $pre = config('database.prefix');
        $tableName = $pre . "timming"; 
        $names=$data['timming_name'];
        print_r($tableName);
        $timming_apiurl="sid=1&status=0&type=2&apiid=".$data['apiid']."&apiurl=".$data['apiurl']."&param=&ac=day&h=24";
         Db::table($tableName)->insert(['timming_name'=>$data['timming_name'],'type' => 1,'timming_apiurl'=>$timming_apiurl,'timming_cjtime' =>30, 'timming_htmlaction'=>"ac=vod&time=1&jump=1",'timming_htmltime' => "30",'timming_status'=>1,'timming_password'=>"123456" ,'timming_addtime'=>time(),'timming_remark'=>"采集 $names 资源并生成上次生成后的内容 密码123456 由牛牛助手添加"]); 
         return $this->success("添加成功");
        

    }
      
    public function update()
    {
        $param = input(); 
        $v = $param['to']; 
        $rq = config("autoconf")['url'] . '/update/zpv9/'; 
        echo "<div class='update'><h1>在线升级中,请稍后......</h1><textarea rows=\"10\" class='layui-textarea' readonly>正在下载升级文件包...\n";
        ob_flush();
        flush();
        sleep(1); 
        $save_path =  RUNTIME_PATH . "update"  . $v . ".zip";
        $downurl = $rq . $v . ".zip";
        $zip = zanpian_curl_get($downurl);
        @fwrite(@fopen($save_path, "wb"), $zip);
        if (!is_file($save_path)) {
            echo "下载升级包失败，请重试...\n";
            exit;
        }
        if (filesize($save_path) < 1) {
            @unlink($save_path);
            echo "下载升级包失败，请重试...\n";
            exit;
        }
        echo "下载升级包完毕...\n";
        echo "正在处理升级包的文件...\n";
        ob_flush();
        flush();
        sleep(1);
        $zipfile = new \com\PclZip();
        $zipfile->PclZip($save_path);
        if (!$zipfile->extract(PCLZIP_OPT_PATH, ROOT_PATH, PCLZIP_OPT_REPLACE_NEWER)) {
            echo $zipfile->error_string . "\n";
            echo "升级失败，请检查系统目录及文件权限！" . "\n";
            exit;
        }
        @unlink($save_path); 
        echo "更新数据缓存文件...\n";
        echo "插件升级完毕...";
        echo "请及时更新API设置token密钥，以恢复默认";
        ob_flush();
        flush();
        echo "</textarea></div>";
        echo "<script type=\"text/javascript\">layui.use([\"jquery\",\"layer\"],function(){var layer=layui.layer,\$=layui.jquery;setTimeout(function(){var index=parent.layer.getFrameIndex(window.name);parent.location.reload();parent.layer.close(index)},\"6000\")});</script>";
    }
    
    // 日志

    public function log()
    {
        $param = input();
        $pre = config('database.prefix');
        $tableName = $pre . "autolog";
        $page = $param['page'];
        $limit = 40;
        if ($page == '' or $page <= 1) {
            $page = 0;
        } else {
            $page = ($page - 1) * $limit;
        }
        if ($limit == '' or $limit <= 1) {
            $limit = 6;
        }
        $this->assign('page', $param['page']);
        $this->assign('limit', $param['limit']);

        $sql = "SELECT * FROM $tableName ";

        $where = ' WHERE 1=1 ';
        if (!empty($param['wd'])) {
            $this->assign('wd', $param['wd']);
            $where = $where . " AND name LIKE '%" . $param['wd'] . "%' ";
        }
        if (!empty($param['kstime']) && !empty($param['jstime'])) {
            $this->assign('kstime', $param['kstime']);
            $this->assign('jstime', $param['jstime']);
            $where = $where . " AND runtime >= '" . $param['kstime'] . ' 00:00:00' . "' AND runtime <= '" . $param['jstime'] . " 23:59:59'";
        }
        $sql = $sql . $where . "ORDER BY id DESC LIMIT " . $page . "," . $limit;
        $list = db()->query($sql);

        $sql = "SELECT COUNT(*) FROM $tableName ";
        $sql = $sql . $where;
        $jg = db()->query($sql);
        $count = $jg[0]['COUNT(*)'];
        $this->assign('list', $list);
        $this->assign('title', '日志列表');
        $this->assign('count', $count);
        return $this->fetch('admin@/auto/log');
    }
    // 删除日志
    public function dellog()
    {
        $param = input();
        $pre = config('database.prefix');
        $tableName = $pre . "autolog";
        $id = input('id');
        if ($id != '') {
            $where = [];
            $where['id'] = $id;
            $res = Db::table($tableName)->where($where)->delete();
            if ($res != 1) {
                return $this->error('删除失败，请重试!');
            }
            return $this->success('删除成功!');
        } else {

            $res = db()->execute("TRUNCATE $tableName;");
            if ($res != 0) {
                return $this->error('清空失败，请重试!');
            }
            return $this->success('清空成功!');
        }
    }
     
    public function img()
    {
        $pre = config('database.prefix');
        $tableName = $pre . "autolog";
        $param = input();
        $rq = config("autoconf")['url'];
        $res = zanpian_curl_get($rq . '/?update-img.html'); 
                $arrlist = auto_json_decode($res);
                 if (!empty($arrlist)) {
                        foreach ($arrlist as $k => $v) {
                            $new = $v['new'];
                            $old = $v['old'];
                            $type = $v['typename'];
                            $sitename = $v['sitename'];
                            if (!empty($new)) {
                                $where['old'] = $old;
                                $where['new'] = $new;
                                $where['name'] = $sitename;
                                $infos = Db::table($tableName)->where($where)->find();
                                if (!$infos) {
                                    $sql = 'UPDATE ' . $pre . 'vod SET vod_pic=REPLACE(vod_pic, "' . $old . '", "' . $new . '")';
                                    $upres = Db::execute($sql);
                                    if ($upres == 0) {
                                        $res = Db::table($tableName)->insert(['name' => $sitename, 'old' => $old, 'new' => $new, 'type' => "图片", 'runtime' => date('Y-m-d H:i:s'), 'updatesql' => "后台手动执行语句为:" . $sql]);
                                    } else {
                                        $res = Db::table($tableName)->insert(['name' => $sitename, 'old' => $old, 'new' => $new, 'type' => "图片", 'runtime' => date('Y-m-d H:i:s'), 'updatesql' => "后台手动执行语句为:" . $sql]);
                                    }
                                }
                            }
                        }
                    }
            
        return $this->success('图片地址替换成功!', 'auto/index');
    }
     public function play()
    {
        $pre = config('database.prefix');
        $tableName = $pre . "autolog";
        $param = input();
        $rq = config("autoconf")['url']; 
         $res = zanpian_curl_get($rq . '/?update-play.html');
                $arrlist = auto_json_decode($res);
                
                if (!empty($arrlist)) {
                        foreach ($arrlist as $k => $v) {
                            $new = $v['new'];
                            $old = $v['old'];
                            $type = $v['typename'];
                            $sitename = $v['sitename'];
                            if (!empty($new)) {
                                $where['old'] = $old;
                                $where['new'] = $new;
                                $where['name'] = $sitename;
                                $infos = Db::table($tableName)->where($where)->find();
                                if (!$infos) {
                                    $sql = 'UPDATE ' . $pre . 'vod SET vod_url=REPLACE(vod_url, "' . $old . '", "' . $new . '")';
                                    $upres = Db::execute($sql);
                                    if ($upres == 0) {
                                        $res = Db::table($tableName)->insert(['name' => $sitename, 'old' => $old, 'new' => $new, 'type' => "播放", 'runtime' => date('Y-m-d H:i:s'), 'updatesql' => "后台手动执行语句为:" . $sql]);
                                    } else {
                                        $res = Db::table($tableName)->insert(['name' => $sitename, 'old' => $old, 'new' => $new, 'type' => "播放", 'runtime' => date('Y-m-d H:i:s'), 'updatesql' => "后台手动执行语句为:" . $sql]);
                                    }
                                }
                            }
                        }
                    }
                    
                     return $this->success('播放地址替换成功!', 'auto/index');
    }
    
}
